<center><a href="ex3.c">Actual source code: ex3.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:21:16+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Demonstrates creating a blocked index set.\n\n"</font>;

<a name="line4">  4: </a><font color="#B22222">/*T</font>
<a name="line5">  5: </a><font color="#B22222">    Concepts: index sets^creating a block index set;</font>
<a name="line6">  6: </a><font color="#B22222">    Concepts: <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>^creating a block index set;</font>

<a name="line8">  8: </a><font color="#B22222">    Description:  Creates an index set based on blocks of integers. Views that index set</font>
<a name="line9">  9: </a><font color="#B22222">    and then destroys it.</font>
<a name="line10"> 10: </a><font color="#B22222">T*/</font>

<a name="line12"> 12: </a> #include <A href="../../../../../include/petscis.h.html">petscis.h</A>

<a name="line16"> 16: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line17"> 17: </a>{
<a name="line19"> 19: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n = 4, inputindices[] = {0,3,9,12},bs = 3,issize,*indices;
<a name="line20"> 20: </a>  <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>             set;
<a name="line21"> 21: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     isblock;

<a name="line23"> 23: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char*)0,help);
<a name="line24"> 24: </a>
<a name="line25"> 25: </a>  <font color="#B22222">/*</font>
<a name="line26"> 26: </a><font color="#B22222">    Create a block index set. The index set has 4 blocks each of <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> 3.</font>
<a name="line27"> 27: </a><font color="#B22222">    The indices are {0,1,2,3,4,5,9,10,11,12,13,14}</font>
<a name="line28"> 28: </a><font color="#B22222">    Note each processor is generating its own index set </font>
<a name="line29"> 29: </a><font color="#B22222">    (in this case they are all identical)</font>
<a name="line30"> 30: </a><font color="#B22222">  */</font>
<a name="line31"> 31: </a>  <A href="../../../../../docs/manualpages/IS/ISCreateBlock.html#ISCreateBlock">ISCreateBlock</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,bs,n,inputindices,&amp;set);
<a name="line32"> 32: </a>  <A href="../../../../../docs/manualpages/IS/ISView.html#ISView">ISView</A>(set,<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);

<a name="line34"> 34: </a>  <font color="#B22222">/*</font>
<a name="line35"> 35: </a><font color="#B22222">    Extract indices from set.</font>
<a name="line36"> 36: </a><font color="#B22222">  */</font>
<a name="line37"> 37: </a>  <A href="../../../../../docs/manualpages/IS/ISGetLocalSize.html#ISGetLocalSize">ISGetLocalSize</A>(set,&amp;issize);
<a name="line38"> 38: </a>  <A href="../../../../../docs/manualpages/IS/ISGetIndices.html#ISGetIndices">ISGetIndices</A>(set,&amp;indices);
<a name="line39"> 39: </a>  <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Printing indices directly\n"</font>);
<a name="line40"> 40: </a>  <font color="#4169E1">for</font> (i=0; i&lt;issize; i++) {
<a name="line41"> 41: </a>    <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"%D\n"</font>,indices[i]);
<a name="line42"> 42: </a>  }
<a name="line43"> 43: </a>  <A href="../../../../../docs/manualpages/IS/ISRestoreIndices.html#ISRestoreIndices">ISRestoreIndices</A>(set,&amp;indices);

<a name="line45"> 45: </a>  <font color="#B22222">/*</font>
<a name="line46"> 46: </a><font color="#B22222">    Extract the block indices. This returns one index per block.</font>
<a name="line47"> 47: </a><font color="#B22222">  */</font>
<a name="line48"> 48: </a>  <A href="../../../../../docs/manualpages/IS/ISBlockGetIndices.html#ISBlockGetIndices">ISBlockGetIndices</A>(set,&amp;indices);
<a name="line49"> 49: </a>  <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Printing block indices directly\n"</font>);
<a name="line50"> 50: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line51"> 51: </a>    <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"%D\n"</font>,indices[i]);
<a name="line52"> 52: </a>  }
<a name="line53"> 53: </a>  <A href="../../../../../docs/manualpages/IS/ISBlockRestoreIndices.html#ISBlockRestoreIndices">ISBlockRestoreIndices</A>(set,&amp;indices);

<a name="line55"> 55: </a>  <font color="#B22222">/*</font>
<a name="line56"> 56: </a><font color="#B22222">    Check if this is really a block index set</font>
<a name="line57"> 57: </a><font color="#B22222">  */</font>
<a name="line58"> 58: </a>  <A href="../../../../../docs/manualpages/IS/ISBlock.html#ISBlock">ISBlock</A>(set,&amp;isblock);
<a name="line59"> 59: </a>  <font color="#4169E1">if</font> (isblock != <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Index set is not blocked!"</font>);

<a name="line61"> 61: </a>  <font color="#B22222">/*</font>
<a name="line62"> 62: </a><font color="#B22222">    Determine the block <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> of the index set</font>
<a name="line63"> 63: </a><font color="#B22222">  */</font>
<a name="line64"> 64: </a>  <A href="../../../../../docs/manualpages/IS/ISBlockGetBlockSize.html#ISBlockGetBlockSize">ISBlockGetBlockSize</A>(set,&amp;bs);
<a name="line65"> 65: </a>  <font color="#4169E1">if</font> (bs != 3) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Block <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> is not 3!"</font>);

<a name="line67"> 67: </a>  <font color="#B22222">/*</font>
<a name="line68"> 68: </a><font color="#B22222">    Get the number of blocks</font>
<a name="line69"> 69: </a><font color="#B22222">  */</font>
<a name="line70"> 70: </a>  <A href="../../../../../docs/manualpages/IS/ISBlockGetSize.html#ISBlockGetSize">ISBlockGetSize</A>(set,&amp;n);
<a name="line71"> 71: </a>  <font color="#4169E1">if</font> (n != 4) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Number of blocks not 4!"</font>);

<a name="line73"> 73: </a>  <A href="../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(set);
<a name="line74"> 74: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line75"> 75: </a>  <font color="#4169E1">return</font> 0;
<a name="line76"> 76: </a>}


</pre>
</body>

</html>
